DL_VerifierImpl< SCHEME_OPTIONS > Class Template Reference

Discrete Log (DL) verifier implementation. More...

Inheritance diagram for DL_VerifierImpl< SCHEME_OPTIONS >:

## Public Member Functions

PK_MessageAccumulator * | NewVerificationAccumulator () const
| Create a new HashTransformation to accumulate the message to be verified. More...
Public Member Functions inherited from DL_ObjectImplBase< DL_VerifierBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS, SCHEME_OPTIONS::PublicKey >
PrivateKey & | AccessPrivateKey ()
PublicKey & | AccessPublicKey ()
const SCHEME_OPTIONS::PublicKey & | GetKey () const
SCHEME_OPTIONS::PublicKey & | AccessKey ()
Public Member Functions inherited from AlgorithmImpl< DL_VerifierBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS::AlgorithmInfo >
std::string | AlgorithmName () const
Public Member Functions inherited from DL_VerifierBase< SCHEME_OPTIONS::Element >
void | InputSignature (PK_MessageAccumulator &messageAccumulator, const byte *signature, size_t signatureLength) const
| Input signature into a message accumulator. More...
bool | VerifyAndRestart (PK_MessageAccumulator &messageAccumulator) const
| Check whether messageAccumulator contains a valid signature and message, and restart messageAccumulator. More...
DecodingResult | RecoverAndRestart (byte *recoveredMessage, PK_MessageAccumulator &messageAccumulator) const
| Recover a message from its signature. More...
Public Member Functions inherited from DL_SignatureSchemeBase< PK_Verifier, DL_PublicKey< SCHEME_OPTIONS::Element > >
size_t | SignatureLength () const
| Provides the signature length. More...
size_t | MaxRecoverableLength () const
| Provides the maximum recoverable length. More...
size_t | MaxRecoverableLengthFromSignatureLength (size_t signatureLength) const
| Provides the maximum recoverable length. More...
bool | IsProbabilistic () const
| Determines if the scheme is probabilistic. More...
bool | AllowNonrecoverablePart () const
| Determines if the scheme has non-recoverable part. More...
bool | RecoverablePartFirst () const
| Determines if the scheme allows recoverable part first. More...
Public Member Functions inherited from PK_Verifier
virtual bool | Verify (PK_MessageAccumulator *messageAccumulator) const
| Check whether messageAccumulator contains a valid signature and message. More...
virtual bool | VerifyMessage (const byte *message, size_t messageLen, const byte *signature, size_t signatureLen) const
| Check whether input signature is a valid signature for input message. More...
virtual DecodingResult | Recover (byte *recoveredMessage, PK_MessageAccumulator *messageAccumulator) const
| Recover a message from its signature. More...
virtual DecodingResult | RecoverMessage (byte *recoveredMessage, const byte *nonrecoverableMessage, size_t nonrecoverableMessageLength, const byte *signature, size_t signatureLength) const
| Recover a message from its signature. More...
Public Member Functions inherited from PK_SignatureScheme
virtual size_t | MaxSignatureLength (size_t recoverablePartLength=0) const
| Provides the maximum signature length produced given the length of the recoverable message part. More...
virtual bool | SignatureUpfront () const
| Determines whether the signature must be input before the message. More...
Public Member Functions inherited from PublicKeyAlgorithm
CryptoMaterial & | AccessMaterial ()
| Retrieves a reference to a Public Key. More...
const CryptoMaterial & | GetMaterial () const
| Retrieves a reference to a Public Key. More...
virtual const PublicKey & | GetPublicKey () const
| Retrieves a reference to a Public Key. More...
Public Member Functions inherited from AsymmetricAlgorithm
void | BERDecode (BufferedTransformation &bt)
| Loads this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Saves this object to a BufferedTransformation. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Additional Inherited Members

Public Types inherited from DL_ObjectImpl< DL_VerifierBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS, SCHEME_OPTIONS::PublicKey >
typedef SCHEME_OPTIONS::PublicKey ::Element | Element
Public Types inherited from DL_ObjectImplBase< DL_VerifierBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS, SCHEME_OPTIONS::PublicKey >
typedef SCHEME_OPTIONS | SchemeOptions
typedef SCHEME_OPTIONS::PublicKey ::Element | Element
Static Public Member Functions inherited from AlgorithmImpl< DL_VerifierBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS::AlgorithmInfo >
static std::string | StaticAlgorithmName ()

## Detailed Description

### template<class SCHEME_OPTIONS>
class DL_VerifierImpl< SCHEME_OPTIONS >

Discrete Log (DL) verifier implementation.

Template Parameters

  SCHEME_OPTIONS | options for the scheme

Definition at line 1864 of file pubkey.h.

## Member Function Documentation

## NewVerificationAccumulator()

template<class SCHEME_OPTIONS >

PK_MessageAccumulator* DL_VerifierImpl< SCHEME_OPTIONS >::NewVerificationAccumulator | ( |  | ) | const

inline virtual

Create a new HashTransformation to accumulate the message to be verified.

Returns
  a pointer to a PK_MessageAccumulator

NewVerificationAccumulator() can be used with all verification methods. Verify() will autimatically delete the accumulator pointer. The caller is responsible for deletion if a method is called that takes a reference.

Implements PK_Verifier.

Definition at line 1867 of file pubkey.h.

The documentation for this class was generated from the following file:

- pubkey.h